/*
 *  Copyright (c) 2018, ARPACORP LTD
 *  All rights reserved
 */

#include <glog/logging.h>
#include <grpcpp/grpcpp.h>
#include <grpcpp/security/credentials.h>
#include <iostream>
#include <string>
#define BOOST_NO_CXX11_SCOPED_ENUMS
#include <boost/filesystem.hpp>
#undef BOOST_NO_CXX11_SCOPED_ENUMS

#include "System/Networking.h"
#include "System/mpc_runtime.h"

#include "arpa_mpc.grpc.pb.h"
#include "input_output/input_output_gateway.h"
#include "input_output/input_output_rpc.h"
#include "server/coordinator_client.h"
#include "server/data_gateway_client.h"
#include "server/mpc_worker.h"
#include "server/openssl_generator.h"

using arpa_mpc::Coordinator;
using arpa_mpc::CoordinatorClient;
using arpa_mpc::FinishMpcRequest;
using arpa_mpc::FinishMpcResponse;
using arpa_mpc::MpcWorker;
using arpa_mpc::RegisterMpcNodeRequest;
using arpa_mpc::RegisterMpcNodeResponse;
using arpa_mpc::StartMpcRequest;
using arpa_mpc::StartMpcResponse;
using grpc::Channel;
using grpc::ClientContext;
using grpc::SecureChannelCredentials;
using grpc::Server;
using grpc::ServerBuilder;
using grpc::ServerContext;
using grpc::Status;
using grpc::StatusCode;
using std::string;

namespace arpa_mpc {
Status MpcWorkerImpl::StartMpc(ServerContext *context,
                               const StartMpcRequest *req,
                               StartMpcResponse *resp) {
  LOG(INFO) << "Received StartMpc request.";

  // Number of FHE Factories we run in parallel.
  int fhefacts = 2;
  // Where to obtain memory, old|empty (default: empty)
  // old: reuse previous memory in Memory-P<i>
  // empty: create new empty memory.
  string memtype = "empty";

  vector<string> player_addr_list;
  vector<string> player_crt_list(req->net_data().players_size());
  vector<string> player_common_name_list(req->net_data().players_size());

  // convert `Worker_x.crt` to `Worker_x`, length() -4
  std::string coworker_crt_folder =
      FLAGS_crt_path.substr(0, FLAGS_crt_path.length() - 4);
  // use worker name create other worker's crt folder
  Status s = SetCoworkerCrtFolder(coworker_crt_folder);
  if (!s.ok()) {
    return s;
  }

  for (int i = 0; i < req->net_data().players_size(); i++) {
    player_addr_list.push_back(req->net_data().players(i).address());

    player_common_name_list[i] = FLAGS_crt_common_name;
    if ((unsigned int)i == req->net_data().player_index()) {
      player_crt_list[i] = FLAGS_crt_path;
    } else {
      std::string other_worker_crt = req->net_data().players(i).cert();
      std::string other_worker_crt_path =
          coworker_crt_folder + "/Worker_" + std::to_string(i) + ".crt";
      // save other worker crt to folder, need to check folder
      OpensslGenerator openssl_generator;
      openssl_generator.SaveCertificate(other_worker_crt,
                                        other_worker_crt_path);

      player_crt_list[i] = other_worker_crt_path;
    }
  }

  // TODO(shaolong): Use the cert files generated by coordinator.
  SystemData sys_data(req->net_data().players_size(), FLAGS_ca_path,
                      player_addr_list, player_crt_list,
                      player_common_name_list, /*fake_off=*/0, /*fake_sac=*/0);

  if (req->net_data().player_index() >= sys_data.n) {
    return Status(grpc::StatusCode::INVALID_ARGUMENT,
                  "Player index is greater than number of nodes.");
  }

  // TODO(jiang): Need to deprecate this and let coordinator pass sharing
  // data to workers.
  /*************************************
   * Initialise the secret sharing     *
   * data and the gfp field data       *
   *************************************/
  istringstream in_sharing_data(req->sharing_data());
  bigint p;
  in_sharing_data >> p;
  LOG(INFO) << "\n\np=" << p;
  gfp::init_field(p);
  ShareData ShD;
  in_sharing_data >> ShD;
  if (ShD.M.nplayers() != sys_data.n) {
    throw data_mismatch();
  }
  if (sys_data.fake_offline == 1) {
    ShD.Otype = Fake;
  }
  Share::init_share_data(ShD);

  // TODO(jiang): Temporarely deprecate the MAC key and FHE key as they are
  // not easily configurable by coordinator. Luckily protocols other than
  // SPDZ doesn't require MAC key and FHE key.
  /*************************************
   *    Load in MAC keys (if any)      *
   *************************************/
  vector<gfp> MacK(Share::SD.nmacs);
  stringstream ss;
  ss << "Data/MKey-" << req->net_data().player_index() << ".key";
  ifstream in_mkey(ss.str().c_str());
  if (in_mkey.fail()) {
    throw file_error(ss.str());
  }
  for (unsigned int i = 0; i < Share::SD.nmacs; i++) {
    in_mkey >> MacK[i];
  }
  in_mkey.close();

  /*************************************
   * Now initialize the FHE data       *
   *    - If needed                    *
   *************************************/
  FHE_Params params;
  FFT_Data PTD;
  Ring Rg;
  ifstream in_fhe_key;
  if (Share::SD.type == Full) {
    stringstream ss;
    ss << "Data/FHE-Key-" << req->net_data().player_index() << ".key";
    in_fhe_key.open(ss.str().c_str());
    bigint p0, p1, pr;
    unsigned int hwt, N;
    in_fhe_key >> N >> p0 >> p1 >> pr >> hwt;
    if (p != pr) {
      throw data_mismatch();
    }

    // Initialize data
    Rg.initialize(2 * N);
    PTD.init(Rg, gfp::get_ZpD());
    params.set(Rg, p0, p1, hwt, sys_data.n);
  } else {  // Make dummy params to avoid having pk/sk as pointers
    Rg.initialize(8);
    params.set(Rg, 17, 17, 1, false);
  }

  /*************************************
   * Load FHE keys                     *
   *************************************/
  FHE_PK pk(params, p);
  FHE_SK sk(params, p);
  if (Share::SD.type == Full) {
    char ch;
    do {
      in_fhe_key.get(ch);
    } while (ch != ':');
    in_fhe_key >> pk >> sk;
    in_fhe_key.close();
  }

  unsigned int number_FHE_threads = 0;
  if (Share::SD.type == Full) {
    number_FHE_threads = fhefacts;
  }

  /* Initialize SSL */
  SSL_CTX *ctx;
  Init_SSL_CTX(ctx, req->net_data().player_index(), sys_data);

  //  Setup offline_control_data ocd
  offline_control_data ocd;
  ocd.minm = (unsigned int)req->ocd().min_mul();
  ocd.mins = (unsigned int)req->ocd().min_sqr();
  ocd.minb = (unsigned int)req->ocd().min_bit();
  ocd.maxm = (unsigned int)req->ocd().max_mul();
  ocd.maxs = (unsigned int)req->ocd().max_sqr();
  ocd.maxb = (unsigned int)req->ocd().max_bit();

  /*
  cout << "(Min,Max) number of ...\n";
  cout << "\t(" << ocd.minm << ",";
  if (ocd.maxm == 0) {
    cout << "infty";
  } else {
    cout << ocd.maxm;
  }
  cout << ") multiplication triples" << endl;

  cout << "\t(" << ocd.mins << ",";
  if (ocd.maxs == 0) {
    cout << "infty";
  } else {
    cout << ocd.maxs;
  }
  cout << ") square pairs" << endl;

  cout << "\t(" << ocd.minb << ",";
  if (ocd.maxb == 0) {
    cout << "infty";
  } else {
    cout << ocd.maxb;
  }
  cout << ") bits" << endl;
  */

  /* Initialize the machine */
  Machine machine;
  int verbose = mpc_context.verbose;
  if (verbose < 0) {
    machine.set_verbose();
    verbose = 0;
  }
  machine.SetUp_Memory(req->net_data().player_index(), memtype);

  std::cout << "Worker #" << req->net_data().player_index()
            << " received input: \n"
            << req->mpc_data().ShortDebugString() << std::endl;
  // Configure the IO in the machine.
  stringstream output;
  unique_ptr<InputOutputBase> io;
  if (mpc_context.input_data != nullptr) {
    io = std::make_unique<InputOutputGateway>(*mpc_context.input_data, output,
                                              true);
  } else {
    io = std::make_unique<InputOutputRpc>(req->mpc_data(), output, true);
  }

  machine.Setup_IO(std::move(io));

  // Load the program.
  std::cout << "Program size: " << req->program().prog_map().size()
            << std::endl;
  int num_online_threads;
  s = machine.schedule.LoadPrograms(req->program().schedule(),
                                    req->program().prog_map(),
                                    &num_online_threads);
  if (!s.ok()) {
    return s;
  }

  MpcRuntime runtime;
  s = runtime.Run(req->net_data().player_index(), num_online_threads, PTD, pk,
                  sk, MacK, ctx, sys_data, machine, ocd, number_FHE_threads,
                  verbose);
  if (!s.ok()) {
    return s;
  }

  // Cleanup upon MPC completion.
  machine.Dump_Memory(req->net_data().player_index());

  std::cout << "Finished serving current MPC request." << std::endl;

  resp->set_success(true);

  Destroy_SSL_CTX(ctx);

  CleanUp(coworker_crt_folder);

  printf("End of prog\n");
  fflush(stdout);

  // TODO(jiang): Make this asynchronous. Return immediately and callback
  // Coordinator.FinishMpc() upon finish.
  return mpc_context.coordinator.FinishMpc(mpc_context.node_id, req->mpc_id(),
                                           output.str());
}

Status MpcWorkerImpl::Heartbeat(ServerContext *context,
                                const HeartbeatRequest *req,
                                HeartbeatResponse *resp) {
  resp->set_healthy(true);
  return Status::OK;
}

void RunServer(MpcContext mpc_context, string server_address) {
  MpcWorkerImpl service(mpc_context);

  ServerBuilder builder;
  // Listen on the given address without any authentication mechanism.
  builder.AddListeningPort(server_address, grpc::InsecureServerCredentials());
  // Register "service" as the instance through which we'll communicate with
  // clients. In this case it corresponds to an *synchronous* service.
  builder.RegisterService(&service);
  // Finally assemble the server.
  std::unique_ptr<Server> server(builder.BuildAndStart());
  std::cout << "Server listening on " << server_address << std::endl;

  // Wait for the server to shutdown. Note that some other thread must be
  // responsible for shutting down the server for this call to ever return.
  server->Wait();
}

Status CreateFolder(std::string_view folder_path_sv) {
  std::string folder_path_str(folder_path_sv);
  std::string error_msg;
  if (folder_path_str.empty()) {
    error_msg = "Create folder error, folder path can't be empty string";
    return Status(StatusCode::INTERNAL, error_msg);
  }

  boost::filesystem::path folder_path(folder_path_str);
  uintmax_t res = boost::filesystem::create_directory(folder_path);

  if (res == 0) {
    error_msg = "Error creating directory in: " + folder_path_str;
    LOG(ERROR) << error_msg;
    return Status(StatusCode::INTERNAL, error_msg);
  }

  LOG(INFO) << "Success create folder: " + folder_path_str;
  return Status::OK;
}

Status CheckPath(std::string_view folder_path_sv, bool *path_exist) {
  std::string folder_path_str = std::string(folder_path_sv);
  std::string error_msg;

  if (folder_path_str.empty()) {
    error_msg =
        "Check folder path error with folder path can't be empty string";
    return Status(StatusCode::INTERNAL, error_msg);
  }

  boost::filesystem::path folder_path(folder_path_str);
  if (boost::filesystem::exists(folder_path)) {
    if (!boost::filesystem::is_directory(folder_path)) {
      *path_exist = false;
      error_msg =
          "Check folder path error with folder path: " + folder_path_str +
          " exist but bot a folder";
      LOG(INFO) << error_msg;
      return Status(StatusCode::INTERNAL, error_msg);
    }

    *path_exist = true;
    LOG(INFO) << "Check folder path error with folder path: " +
                     folder_path_str + " exist";
    return Status::OK;
  }

  *path_exist = false;
  LOG(INFO) << "folder path: " + folder_path_str + " not exsit";
  return Status::OK;
}

Status SetCoworkerCrtFolder(std::string_view folder_path_sv) {
  std::string folder_path = std::string(folder_path_sv);
  std::string error_msg;
  bool path_exist = false;

  Status s = CheckPath(folder_path, &path_exist);
  if (!s.ok()) {
    return s;
  }

  if (!path_exist) {
    s = CreateFolder(folder_path);
    return s;
  }

  LOG(INFO) << "Success set coworker crt folder at: " + folder_path;
  return Status::OK;
}

// this function clean up coworker folder and self crt file
grpc::Status CleanUp(std::string_view folder_path_sv) {
  std::string error_msg;
  std::string folder_path_str = std::string(folder_path_sv);
  boost::filesystem::path folder_path(folder_path_str);
  bool folder_exist = false;

  if (folder_path_str.empty()) {
    error_msg =
        "Check folder path error with folder path can't be empty string";
    return Status(StatusCode::INTERNAL, error_msg);
  }

  Status s = CheckPath(folder_path_str, &folder_exist);
  if (!s.ok()) {
    return s;
  }

  if (!folder_exist) {
    error_msg =
        "Clean up error with folder path doesn't exist: " + folder_path_str;
    return Status(StatusCode::INTERNAL, error_msg);
  }

  // Delete coworkder folder
  uintmax_t res = boost::filesystem::remove_all(folder_path);
  if (res == 0) {
    error_msg = "Clean up error with no zero file deleted";
    return Status(StatusCode::INTERNAL, error_msg);
  }

  LOG(INFO) << "Success clean up all coworker files and folder";
  return Status::OK;
}

}  // namespace arpa_mpc
